org.apache.lucene.search.similarities

## Class TFIDFSimilarity

- java.lang.Object
- - org.apache.lucene.search.similarities.Similarity
  - - org.apache.lucene.search.similarities.TFIDFSimilarity

- Direct Known Subclasses:
    ClassicSimilarity

      public abstract class TFIDFSimilarity
      extends Similarity

  Implementation of `Similarity` with the Vector Space Model.

  Expert: Scoring API.

  TFIDFSimilarity defines the components of Lucene scoring. Overriding computation of these components is a convenient way to alter Lucene scoring.

  Suggested reading: Introduction To Information Retrieval, Chapter 6.

  The following describes how Lucene scoring evolves from underlying information retrieval models to (efficient) implementation. We first brief on VSM Score, then derive from it Lucene's Conceptual Scoring Formula, from which, finally, evolves Lucene's Practical Scoring Function (the latter is connected directly with Lucene classes and methods).

  Lucene combines Boolean model (BM) of Information Retrieval with Vector Space Model (VSM) of Information Retrieval - documents "approved" by BM are scored by VSM.

  In VSM, documents and queries are represented as weighted vectors in a multi-dimensional space, where each distinct index term is a dimension, and weights are Tf-idf values.

  VSM does not require weights to be Tf-idf values, but Tf-idf values are believed to produce search results of high quality, and so Lucene is using Tf-idf. Tf and Idf are described in more detail below, but for now, for completion, let's just say that for given term t and document (or query) x, Tf(t,x) varies with the number of occurrences of term t in x (when one increases so does the other) and idf(t) similarly varies with the inverse of the number of index documents containing term t.

  VSM score of document d for query q is the Cosine Similarity of the weighted query vectors V(q) and V(d):

  cosine-similarity(q,d) = |
  V(q) · V(d)
  –––––––––
  |V(q)| |V(d)|
  VSM Score

  Where V(q) · V(d) is the dot product of the weighted vectors, and |V(q)| and |V(d)| are their Euclidean norms.

  Note: the above equation can be viewed as the dot product of the normalized weighted vectors, in the sense that dividing V(q) by its euclidean norm is normalizing it to a unit vector.

  Lucene refines VSM score for both search quality and usability:

  - Normalizing V(d) to the unit vector is known to be problematic in that it removes all document length information. For some documents removing this info is probably ok, e.g. a document made by duplicating a certain paragraph 10 times, especially if that paragraph is made of distinct terms. But for a document which contains no duplicated paragraphs, this might be wrong. To avoid this problem, a different document length normalization factor is used, which normalizes to a vector equal to or larger than the unit vector: doc-len-norm(d).
  - At indexing, users can specify that certain documents are more important than others, by assigning a document boost. For this, the score of each document is also multiplied by its boost value doc-boost(d).
  - Lucene is field based, hence each query term applies to a single field, document length normalization is by the length of the certain field, and in addition to document boost there are also document fields boosts.
  - The same field can be added to a document during indexing several times, and so the boost of that field is the multiplication of the boosts of the separate additions (or parts) of that field within the document.
  - At search time users can specify boosts to each query, sub-query, and each query term, hence the contribution of a query term to the score of a document is multiplied by the boost of that query term query-boost(q).
  - A document may match a multi term query without containing all the terms of that query (this is correct for some of the queries), and users can further reward documents matching more query terms through a coordination factor, which is usually larger when more terms are matched: coord-factor(q,d).

  Under the simplifying assumption of a single field in the index, we get Lucene's Conceptual scoring formula:

  score(q,d) = coord-factor(q,d) · query-boost(q) · |
  V(q) · V(d)
  –––––––––
  |V(q)|
  | · doc-len-norm(d) · doc-boost(d)
  Lucene Conceptual Scoring Formula

  The conceptual formula is a simplification in the sense that (1) terms and documents are fielded and (2) boosts are usually per query term rather than per query.

  We now describe how Lucene implements this conceptual scoring formula, and derive from it Lucene's Practical Scoring Function.

  For efficient score computation some scoring components are computed and aggregated in advance:

  - Query-boost for the query (actually for each query term) is known when search starts.
  - Query Euclidean norm |V(q)| can be computed when search starts, as it is independent of the document being scored. From search optimization perspective, it is a valid question why bother to normalize the query at all, because all scored documents will be multiplied by the same |V(q)|, and hence documents ranks (their order by score) will not be affected by this normalization. There are two good reasons to keep this normalization:
    - Recall that Cosine Similarity can be used find how similar two documents are. One can use Lucene for e.g. clustering, and use a document as a query to compute its similarity to other documents. In this use case it is important that the score of document d3 for query d1 is comparable to the score of document d3 for query d2. In other words, scores of a document for two distinct queries should be comparable. There are other applications that may require this. And this is exactly what normalizing the query vector V(q) provides: comparability (to a certain extent) of two or more queries.
    - Applying query normalization on the scores helps to keep the scores around the unit vector, hence preventing loss of score data because of floating point precision limitations.
  - Document length norm doc-len-norm(d) and document boost doc-boost(d) are known at indexing time. They are computed in advance and their multiplication is saved as a single value in the index: norm(d). (In the equations below, norm(t in d) means norm(field(t) in doc d) where field(t) is the field associated with term t.)

  Lucene's Practical Scoring Function is derived from the above. The color codes demonstrate how it relates to those of the conceptual formula:

  score(q,d) = coord(q,d) · queryNorm(q) · | ∑ | ( tf(t in d) · idf(t)2 · t.getBoost() · norm(t,d) )
  | t in q |
  Lucene Practical Scoring Function

  where

  1. tf(t in d) correlates to the term's frequency, defined as the number of times term t appears in the currently scored document d. Documents that have more occurrences of a given term receive a higher score. Note that tf(t in q) is assumed to be 1 and therefore it does not appear in this equation, However if a query contains twice the same term, there will be two term-queries with that same term and hence the computation would still be correct (although not very efficient). The default computation for tf(t in d) in `ClassicSimilarity` is:

     `tf(t in d)` = | frequency½

  2. idf(t) stands for Inverse Document Frequency. This value correlates to the inverse of docFreq (the number of documents in which the term t appears). This means rarer terms give higher contribution to the total score. idf(t) appears for t in both the query and the document, hence it is squared in the equation. The default computation for idf(t) in `ClassicSimilarity` is:

     `idf(t)` = | 1 + log ( |
     docCount+1
     –––––––––
     docFreq+1
     | )

  3. coord(q,d) is a score factor based on how many of the query terms are found in the specified document. Typically, a document that contains more of the query's terms will receive a higher score than another document with fewer query terms. This is a search time factor computed in `coord(q,d)` by the Similarity in effect at search time.
  4. queryNorm(q) is a normalizing factor used to make scores between queries comparable. This factor does not affect document ranking (since all ranked documents are multiplied by the same factor), but rather just attempts to make scores from different queries (or even different indexes) comparable. This is a search time factor computed by the Similarity in effect at search time. The default computation in `ClassicSimilarity` produces a Euclidean norm:

     queryNorm(q) = `queryNorm(sumOfSquaredWeights)` = |
     1
     ––––––––––––––
     sumOfSquaredWeights½

     The sum of squared weights (of the query terms) is computed by the query `Weight` object. For example, a `BooleanQuery` computes this value as:

     `sumOfSquaredWeights` = `q.getBoost()` 2 · | ∑ | ( idf(t) · t.getBoost() ) 2
     | t in q |

  5. t.getBoost() is a search time boost of term t in the query q as specified in the query text (see query syntax), or as set by wrapping with `BoostQuery`. Notice that there is really no direct API for accessing a boost of one term in a multi term query, but rather multi terms are represented in a query as multi `TermQuery` objects, and so the boost of a term in the query is accessible by calling the sub-query `getBoost()`.
  6. norm(t,d) encapsulates a few (indexing time) boost and length factors:
     - Field boost - set by calling `field.setBoost()` before adding the field to a document.
     - lengthNorm - computed when the document is added to the index in accordance with the number of tokens of this field in the document, so that shorter fields contribute more to the score. LengthNorm is computed by the Similarity class in effect at indexing.
     The `computeNorm(org.apache.lucene.index.FieldInvertState)` method is responsible for combining all of these factors into a single float.

     When a document is added to the index, all the above factors are multiplied. If the document has multiple fields with the same name, all their boosts are multiplied together:

     norm(t,d) = lengthNorm · | ∏ | `f.boost`()
     | field f in d named as t |

     Note that search time is too late to modify this norm part of scoring, e.g. by using a different `Similarity` for search.
  See Also:
    `IndexWriterConfig.setSimilarity(Similarity)`, `IndexSearcher.setSimilarity(Similarity)`

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.search.similarities.Similarity

      `Similarity.SimScorer, Similarity.SimWeight`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TFIDFSimilarity()` Sole constructor.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `computeNorm(FieldInvertState state)` Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).
    `Similarity.SimWeight` | `computeWeight(CollectionStatistics collectionStats, TermStatistics... termStats)` Compute any collection-level weight (e.g.
    `abstract float` | `coord(int overlap, int maxOverlap)` Computes a score factor based on the fraction of all query terms that a document contains.
    `abstract float` | `decodeNormValue(long norm)` Decodes a normalization factor stored in an index.
    `abstract long` | `encodeNormValue(float f)` Encodes a normalization factor for storage in an index.
    `abstract float` | `idf(long docFreq, long docCount)` Computes a score factor based on a term's document frequency (the number of documents which contain the term).
    `Explanation` | `idfExplain(CollectionStatistics collectionStats, TermStatistics termStats)` Computes a score factor for a simple term and returns an explanation for that score factor.
    `Explanation` | `idfExplain(CollectionStatistics collectionStats, TermStatistics[] termStats)` Computes a score factor for a phrase.
    `abstract float` | `lengthNorm(FieldInvertState state)` Compute an index-time normalization value for this field instance.
    `abstract float` | `queryNorm(float sumOfSquaredWeights)` Computes the normalization value for a query given the sum of the squared weights of each of the query terms.
    `abstract float` | `scorePayload(int doc, int start, int end, BytesRef payload)` Calculate a scoring factor based on the data in the payload.
    `Similarity.SimScorer` | `simScorer(Similarity.SimWeight stats, LeafReaderContext context)` Creates a new `Similarity.SimScorer` to score matching documents from a segment of the inverted index.
    `abstract float` | `sloppyFreq(int distance)` Computes the amount of a sloppy phrase match, based on an edit distance.
    `abstract float` | `tf(float freq)` Computes a score factor based on a term or phrase's frequency in a document.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TFIDFSimilarity

          public TFIDFSimilarity()

      Sole constructor. (For invocation by subclass constructors, typically implicit.)

  - ### Method Detail

    - #### coord

          public abstract float coord(int overlap,
                                      int maxOverlap)

      Computes a score factor based on the fraction of all query terms that a document contains. This value is multiplied into scores.

      The presence of a large portion of the query terms indicates a better match with the query, so implementations of this method usually return larger values when the ratio between these parameters is large and smaller values when the ratio between them is small.

      Overrides:
        `coord` in class `Similarity`
      Parameters:
        `overlap` - the number of query terms matched in the document
        `maxOverlap` - the total number of terms in the query
      Returns:
        a score factor based on term overlap with the query

    - #### queryNorm

          public abstract float queryNorm(float sumOfSquaredWeights)

      Computes the normalization value for a query given the sum of the squared weights of each of the query terms. This value is multiplied into the weight of each query term. While the classic query normalization factor is computed as 1/sqrt(sumOfSquaredWeights), other implementations might completely ignore sumOfSquaredWeights (ie return 1).

      This does not affect ranking, but the default implementation does make scores from different queries more comparable than they would be by eliminating the magnitude of the Query vector as a factor in the score.

      Overrides:
        `queryNorm` in class `Similarity`
      Parameters:
        `sumOfSquaredWeights` - the sum of the squares of query term weights
      Returns:
        a normalization factor for query weights

    - #### tf

          public abstract float tf(float freq)

      Computes a score factor based on a term or phrase's frequency in a document. This value is multiplied by the `idf(long, long)` factor for each term in the query and these products are then summed to form the initial score for a document.

      Terms and phrases repeated in a document indicate the topic of the document, so implementations of this method usually return larger values when `freq` is large, and smaller values when `freq` is small.

      Parameters:
        `freq` - the frequency of a term within a document
      Returns:
        a score factor based on a term's within-document frequency

    - #### idfExplain

          public Explanation idfExplain(CollectionStatistics collectionStats,
                                        TermStatistics termStats)

      Computes a score factor for a simple term and returns an explanation for that score factor.

      The default implementation uses:

           idf(docFreq, docCount);

      Note that `CollectionStatistics.docCount()` is used instead of `IndexReader#numDocs()` because also `TermStatistics.docFreq()` is used, and when the latter is inaccurate, so is `CollectionStatistics.docCount()`, and in the same direction. In addition, `CollectionStatistics.docCount()` does not skew when fields are sparse.
      Parameters:
        `collectionStats` - collection-level statistics
        `termStats` - term-level statistics for the term
      Returns:
        an Explain object that includes both an idf score factor and an explanation for the term.

    - #### idfExplain

          public Explanation idfExplain(CollectionStatistics collectionStats,
                                        TermStatistics[] termStats)

      Computes a score factor for a phrase.

      The default implementation sums the idf factor for each term in the phrase.

      Parameters:
        `collectionStats` - collection-level statistics
        `termStats` - term-level statistics for the terms in the phrase
      Returns:
        an Explain object that includes both an idf score factor for the phrase and an explanation for each term.

    - #### idf

          public abstract float idf(long docFreq,
                                    long docCount)

      Computes a score factor based on a term's document frequency (the number of documents which contain the term). This value is multiplied by the `tf(float)` factor for each term in the query and these products are then summed to form the initial score for a document.

      Terms that occur in fewer documents are better indicators of topic, so implementations of this method usually return larger values for rare terms, and smaller values for common terms.

      Parameters:
        `docFreq` - the number of documents which contain the term
        `docCount` - the total number of documents in the collection
      Returns:
        a score factor based on the term's document frequency

    - #### lengthNorm

          public abstract float lengthNorm(FieldInvertState state)

      Compute an index-time normalization value for this field instance.

      This value will be stored in a single byte lossy representation by `encodeNormValue(float)`.

      Parameters:
        `state` - statistics of the current field (such as length, boost, etc)
      Returns:
        an index-time normalization value

    - #### computeNorm

          public final long computeNorm(FieldInvertState state)

      Description copied from class: `Similarity`
      Computes the normalization value for a field, given the accumulated state of term processing for this field (see `FieldInvertState`).

      Matches in longer fields are less precise, so implementations of this method usually set smaller values when `state.getLength()` is large, and larger values when `state.getLength()` is small.

      Specified by:
        `computeNorm` in class `Similarity`
      Parameters:
        `state` - current processing state for this field
      Returns:
        computed norm value

    - #### decodeNormValue

          public abstract float decodeNormValue(long norm)

      Decodes a normalization factor stored in an index.
      See Also:
        `encodeNormValue(float)`

    - #### encodeNormValue

          public abstract long encodeNormValue(float f)

      Encodes a normalization factor for storage in an index.

    - #### sloppyFreq

          public abstract float sloppyFreq(int distance)

      Computes the amount of a sloppy phrase match, based on an edit distance. This value is summed for each sloppy phrase match in a document to form the frequency to be used in scoring instead of the exact term count.

      A phrase match with a small edit distance to a document passage more closely matches the document, so implementations of this method usually return larger values when the edit distance is small and smaller values when it is large.

      Parameters:
        `distance` - the edit distance of this sloppy phrase match
      Returns:
        the frequency increment for this match
      See Also:
        `PhraseQuery.getSlop()`

    - #### scorePayload

          public abstract float scorePayload(int doc,
                                             int start,
                                             int end,
                                             BytesRef payload)

      Calculate a scoring factor based on the data in the payload. Implementations are responsible for interpreting what is in the payload. Lucene makes no assumptions about what is in the byte array.
      Parameters:
        `doc` - The docId currently being scored.
        `start` - The start position of the payload
        `end` - The end position of the payload
        `payload` - The payload byte array to be scored
      Returns:
        An implementation dependent float to be used as a scoring factor

    - #### computeWeight

          public final Similarity.SimWeight computeWeight(CollectionStatistics collectionStats,
                                                          TermStatistics... termStats)

      Description copied from class: `Similarity`
      Compute any collection-level weight (e.g. IDF, average document length, etc) needed for scoring a query.
      Specified by:
        `computeWeight` in class `Similarity`
      Parameters:
        `collectionStats` - collection-level statistics, such as the number of tokens in the collection.
        `termStats` - term-level statistics, such as the document frequency of a term across the collection.
      Returns:
        SimWeight object with the information this Similarity needs to score a query.

    - #### simScorer

          public final Similarity.SimScorer simScorer(Similarity.SimWeight stats,
                                                      LeafReaderContext context)
                                               throws IOException

      Description copied from class: `Similarity`
      Creates a new `Similarity.SimScorer` to score matching documents from a segment of the inverted index.
      Specified by:
        `simScorer` in class `Similarity`
      Parameters:
        `stats` - collection information from `Similarity.computeWeight(CollectionStatistics, TermStatistics...)`
        `context` - segment of the inverted index to be scored.
      Returns:
        SloppySimScorer for scoring documents across `context`
      Throws:
        `IOException` - if there is a low-level I/O error

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.